summaryrefslogtreecommitdiffstats
path: root/wpa_actiond/netcfg-wpa_actiond-action
diff options
context:
space:
mode:
Diffstat (limited to 'wpa_actiond/netcfg-wpa_actiond-action')
-rwxr-xr-xwpa_actiond/netcfg-wpa_actiond-action54
1 files changed, 54 insertions, 0 deletions
diff --git a/wpa_actiond/netcfg-wpa_actiond-action b/wpa_actiond/netcfg-wpa_actiond-action
new file mode 100755
index 0000000..f273b3b
--- /dev/null
+++ b/wpa_actiond/netcfg-wpa_actiond-action
@@ -0,0 +1,54 @@
+#! /bin/bash
+
+interface=$1
+ssid=$2
+profile=$3
+action=$4
+
+. /usr/lib/network/network
+[[ $profile ]] && load_profile "$profile"
+
+case $action in
+ CONNECT)
+ if [[ -z $profile ]]; then
+ dhcpcd $interface
+ exit $?
+ fi
+ if ! $CONN_DIR/ethernet up "$profile"; then
+ exit 1 # what to do if fail?
+ fi
+
+ set_profile up "$profile"
+
+ if ! ( eval $POST_UP ); then # JP: sandbox the eval
+ # failing POST_UP will take interface down
+ "$CONN_DIR/$ethernet" down "$profile"
+ exit 1
+ fi
+ ;;
+ DISCONNECT)
+ if [[ -z $profile ]]; then
+ dhcpcd -k $interface
+ exit $?
+ fi
+ if ! ( eval $PRE_DOWN ); then # JP: sandbox the eval
+ exit 1
+ fi
+ if ! "$CONN_DIR/ethernet" down "$profile"; then
+ exit 1
+ fi
+ if ! ( eval $POST_DOWN ); then # JP: sandbox the eval
+ exit 1
+ fi
+ set_profile down "$profile"
+ ;;
+ LOST|REESTABLISHED)
+ # Not handled.
+ exit 0
+ ;;
+ *)
+ # ???
+ exit 1
+ ;;
+esac
+